﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win.UltraWinEditors;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
		private UltraCombo _cmbTest = new UltraCombo();

        public Form1()
        {
            InitializeComponent();
			LoadDataTables();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			_cmbTest.InitializeLayout += new InitializeLayoutEventHandler(_cmbTest_InitializeLayout);

			_cmbTest.DropDownStyle = UltraComboStyle.DropDownList;

			this._cmbTest.DisplayMember = "NAME";
			this._cmbTest.ValueMember = "ID";
			this._cmbTest.CheckedListSettings.CheckStateMember = "CHECKED";
			this._cmbTest.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.CheckedItems;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
			//UltraGridColumn column = e.Layout.Bands[0].Columns.Add("Checked List");
			//column.DataType = typeof(List<object>);
			//column.EditorControl = _cmbTest;

			e.Layout.ViewStyle = ViewStyle.SingleBand;
			e.Layout.GroupByBox.Hidden = true;

			foreach (UltraGridColumn col in e.Layout.Bands[0].Columns)
			{
				switch (col.Key.ToUpper())
				{
					case "CONTRACTS":
						col.Header.Caption = "Contracts";
						break;

					case "START_DATE":
						col.Header.Caption = "Start Date";
						break;

					case "END_DATE":
						col.Header.Caption = "End Date";
						break;

					case "FUNDING_SOURCES":
						col.Header.Caption = "Funding Sources";
						col.EditorControl = _cmbTest;
						col.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
						col.Hidden = false;
						break;

					default:
						col.Hidden = true;
						break;
				}
			}

			e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;
        }

		private void _cmbTest_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            UltraGridColumn column = e.Layout.Bands[0].Columns.Add("CHECKED");
            column.DataType = typeof(bool);
			column.Header.Caption = "Apply";
        }

		private void LoadDataTables()
		{
			DataTable dt = new DataTable();
			dt.Columns.Add("CONTRACTS", typeof(string));
			dt.Columns.Add("START_DATE", typeof(DateTime));
			dt.Columns.Add("END_DATE", typeof(DateTime));
			dt.Columns.Add("FUNDING_SOURCES", typeof(List<object>));

			dt.Rows.Add(new object[4] { 
				"National Contract", 
				DateTime.Now, 
				new DateTime(DateTime.Now.Year, 12, 31),
				DBNull.Value});

			List<object> list1 = new List<object>();
			list1.Add(1);
			list1.Add(2);

			dt.Rows.Add(new object[4] { 
				"State Contract", 
				DateTime.Now, 
				new DateTime(DateTime.Now.Year, 12, 31),
				list1});

			List<object> list2 = new List<object>();
			list2.Add(3);
			list2.Add(5);

			dt.Rows.Add(new object[4] { 
				"State Contract", 
				DateTime.Now, 
				new DateTime(DateTime.Now.Year, 12, 31),
				list2});

			ugTest.DataSource = dt;

			DataTable dt2 = new DataTable();
			dt2.Columns.Add("ID", typeof(int));
			dt2.Columns.Add("NAME", typeof(string));

			dt2.Rows.Add(new object[2] { 1, "One" });
			dt2.Rows.Add(new object[2] { 2, "Two" });
			dt2.Rows.Add(new object[2] { 3, "Three" });
			dt2.Rows.Add(new object[2] { 4, "Four" });
			dt2.Rows.Add(new object[2] { 5, "Five" });

			_cmbTest.DataSource = dt2;
		}
    }
}
